#include <AccelStepper.h>

// Define some steppers and the pins the will use
AccelStepper stepper1; // Defaults to AccelStepper::FULL4WIRE (4 pins) on 2, 3, 4, 5
AccelStepper stepper2(AccelStepper::FULL4WIRE, 6, 7, 8, 9);
AccelStepper stepper3(AccelStepper::FULL4WIRE, 10, 11, 12, 13);

byte NRot = 18; //value of rotation
int NRot_tmp = 0;
bool lay_dir = true;
int lay_tmp = 0;
int lay_min = 0;
int lay_max = 3;
long X = 20;
char inc_b; // incoming serial data;

void forward()
{
    stepper2.runToNewPosition(40);
    stepper2.setCurrentPosition(0);
    stepper3.runToNewPosition(20);;
    stepper3.setCurrentPosition(0);
    stepper2.runToNewPosition(-40);
    stepper2.setCurrentPosition(0);
    stepper3.runToNewPosition(-20);
    stepper3.setCurrentPosition(0);
}

void backward()
{
    stepper2.runToNewPosition(-40);
    stepper2.setCurrentPosition(0);
    stepper3.runToNewPosition(-20);
    stepper3.setCurrentPosition(0);
    stepper2.runToNewPosition(40);
    stepper2.setCurrentPosition(0);
    stepper3.runToNewPosition(20);
    stepper3.setCurrentPosition(0);
}

void laying()
{
    if (lay_dir == true && lay_tmp < lay_max || lay_dir == true && lay_tmp == lay_min || lay_dir == false && lay_tmp == lay_min)
    {
      stepper1.runToNewPosition(X);
      stepper1.setCurrentPosition(0);
      lay_tmp++;
      lay_dir = true;
      Serial.print('+');
    }
    else
    {
      stepper1.runToNewPosition(-X);
      stepper1.setCurrentPosition(0);
      lay_tmp--;
      lay_dir = false;
      Serial.print('-');
    }
}
/*
void laying()
{
    stepper1.runToNewPosition(X);
    stepper1.setCurrentPosition(0);
}
*/
void laying_b()
{
    stepper1.runToNewPosition(-X);
    stepper1.setCurrentPosition(0);
}

void laying_home()
{
  stepper1.disableOutputs();
  stepper2.disableOutputs();
  stepper3.disableOutputs();
}

void setup()
{  
    Serial.begin(9600);
    Serial.println("Enter 'f' or 'b' for dir then value for number of rotation");
    stepper1.setMaxSpeed(1000.0);
    //stepper1.setSpeed(1000);
    stepper1.setAcceleration(600.0);
    
    stepper2.setMaxSpeed(1000.0);
    stepper2.setAcceleration(600.0);
	
    stepper3.setMaxSpeed(1000.0);
    stepper3.setAcceleration(600.0);
}

void loop()
{
    if (Serial.available())
    {
      delay(10);
      inc_b = Serial.read();
      if (inc_b == 'f') //forward
      {
        NRot_tmp = 0;
        while(NRot_tmp < NRot)
        {
          forward();
          laying();
          NRot_tmp++;
        }
        lay_dir = true;
        
      Serial.flush();
      }
      else if (inc_b == 'b')  //backward
      {
        NRot_tmp = 0;
        while(NRot_tmp < NRot)
        {
          backward();
          laying();
          NRot_tmp++;
        }
        lay_dir = true;
        
        Serial.flush();
      }
      /*
      else if (inc_b == 'l')  //laying
      {
      laying();
      Serial.flush();
      }
      */
      else if (inc_b == 'q')  //exit
      {
      laying_home();
      Serial.flush();
      }
    }
}
